/**
 * The Lab class represents a Lab class with all of students and
 * referred information
 * It holds the student details relevant in our context.
 *
 * @author SpNova
 * @version 0.0
 */

public class Lab {
    // stores a list of attendant students
    private Student[] students;
    // global variable for lab class average grade
    private int avg;
    // global variable for the day that lab class runs
    private String day;
    // global variable for capacity of lab class
    private int capacity;
    // global variable for attending number of students
    private int currentSize;

    /**
     * constructor for lab class
     *
     * @param cap set capacity of lab class
     * @param d   set day of lab class
     */
    public Lab(int cap, String d) {
        capacity = cap;
        day = d;
        students = new Student[cap];
    }

    /**
     * checks if lab class has capacity to enroll a student or not
     * enrolls student to the lab class if there is enough capacity
     * prints an error if lab is full
     *
     * @param std a student instance is called
     */
    public void enrollStudent(Student std) {

        if (currentSize < capacity) {
            students[currentSize] = std;
            currentSize++;
        } else {
            System.out.println("Lab is full!!!");
        }
    }

    /**
     * prints all lab students personal data
     * at last prints the average grade of all students in lab class
     */
    public void print() {
        for (int i = 0; i < students.length; i++) {
            System.out.println("FirstName: " + students[i].getFirstName() + "\tLastName: " + students[i].getLastName() +
                    "\t\tID:" + students[i].getId() + "\t\tGrade:" + students[i].getGrade());
        }
        calculateAvg();
        System.out.println("AVERAGE GRADE: " + getAvg());
    }

    /**
     * returns a list of all attendant students
     *
     * @return students list
     */
    public Student[] getStudents() {
        return students;
    }

    /**
     * student field must be an array that contains all required data
     *
     * @param students set students list
     */
    public void setStudents(Student[] students) {
        this.students = students;
    }

    /**
     * get average grade of the class
     *
     * @return average field in INTEGER
     */
    public int getAvg() {
        return avg;
    }

    /**
     * calculates the average grade of class
     */
    public void calculateAvg() {
        int sum = 0;
        for (int i = 0; i < students.length; i++) {
            sum = sum + students[i].getGrade();
        }
        avg = sum / students.length;
    }

    /**
     * get the day that student attends the class
     *
     * @return day field
     */
    public String getDay() {
        return day;
    }

    /**
     * @param day set the day that student attends the class
     */
    public void setDay(String day) {
        this.day = day;
    }

    /**
     * get capacity of the class
     *
     * @return capacity field
     */
    public int getCapacity() {
        return capacity;
    }

    /**
     * @param capacity set capacity of the class
     */
    public void setCapacity(int capacity) {
        this.capacity = capacity;
    }

    /**
     * changes the first name of first student passed to this class
     */
    public void changeFirstStudentsFirstName() {
        students[1].setFirstName("FOO");
    }
}